#!/usr/bin/env python3
# -*- coding: utf-8 -*-
from sqlalchemy.orm import Session
from sqlalchemy import text, exists, and_, or_, not_
from sqlalchemy.sql import func
from database import get_db
from models import *
from extensions import logger
from utils import *

def get_dept_name_by_id(db: Session, dept_id: int) -> str:
    row = db.query(SysDept).filter(SysDept.dept_id == dept_id).first()
    if row is not None:
        return row.dept_name
    
    return ""

def get_dept_id_by_name(db: Session, dept_name: str) -> int:
    row = db.query(SysDept).filter(SysDept.dept_name == dept_name).first()
    if row is not None:
        return row.dept_id
    
    return 0