#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from . import mpfun
from models import *
from sqlalchemy.orm import Session
from database import get_local_db

# 系统用户角色表

# 加密和HMAC签名
def sign_row(db: Session, row: SysUserPost) -> None:
    if row.sign != '':
        return
    
    user_id = str(row.user_id) # 用户ID
    post_id = str(row.post_id) # 岗位ID

    sign_data = ",".join([user_id, post_id])
    sign_hmac = mpfun.sign_data(sign_data)
    # print('sign_tbl_user sign_data:', sign_data)
    # print('sign_tbl_user sign_hmac:', sign_hmac)

    row.sign = sign_hmac
    
    db.commit()

# 比较字段合并字符串是否和MAC值匹配上,调用密码服务器[验证HMAC]接口
def sign_valid_row(row: SysUserPost) -> bool:
    return True

    if row.sign == '':
        return True

    # 关键字段合并字符串
    sign_data = get_sign_str(row)
    # print('sys_user sign_data:', sign_data)
    
    # 原HMACSM3数值
    sign_hmac = row.sign
    # print('sign_hmac:', sign_hmac)

    return mpfun.hmac_verify(sign_data, sign_hmac)

# 生成待签名的字符串
def get_sign_str(row: SysUserPost) -> str:
    user_id = str(row.user_id) # 用户ID
    post_id = str(row.post_id) # 岗位ID

    # 关键字段合并字符串
    sign_data = ",".join([user_id, post_id])
    return sign_data

# 生成HAMC签名值
def get_sign_hmac(row: SysUserPost) -> str:
    sign_data = get_sign_str(row)
    return mpfun.sign_data(sign_data) 

# 对所有数据进行签名
def sign_table():
    print('sign_sys_user_post table =====>>>')
    with get_local_db() as db:
        rows = db.query(SysUserPost).filter(SysUserPost.sign == '').all()
        for row in rows:
            sign_row(db, row)