
#!/usr/bin/env python3
# -*- coding: utf-8 -*-
from datetime import datetime
from sqlalchemy.orm import Session
from utils import *
from utils.redis_util import *
from models import *
from exceptions import *
from database import get_local_db
from extensions import logger
import traceback

def daiban_proc():
    try:
        with get_local_db() as db:
            logger.info(datetime.now())

            check_qyjcxx_ok(db)
            check_qyyjya_ok(db)
            check_yjylzj_ok(db)

            # db.query(YstQyjcxxEntity).update({"update_time": datetime.now()})
            # db.commit()

            # db.query(YstQyyjyaEntity).update({"update_time": datetime.now()})
            # db.commit()
            
            # db.query(YstYjylzjEntity).update({"update_time": datetime.now()})
            # db.commit()
            
    except Exception as e:
        traceback.print_exc()
    
# 企业基础信息
def check_qyjcxx_ok(db: Session):
    sxmc = '应急企业基础信息'
    rows = db.query(YstQyjcxxEntity).filter(YstQyjcxxEntity.status == 88).all()
    for row in rows:
        update_yst_status(row, 2, sxmc, db)

    rows = db.query(YstQyjcxxEntity).filter(YstQyjcxxEntity.status == 99).all()
    for row in rows:
        update_yst_status(row, 3, sxmc, db)

# 应急预案上报
def check_qyyjya_ok(db: Session):
    sxmc = '应急预案上报'
    rows = db.query(YstQyyjyaEntity).filter(YstQyyjyaEntity.status == 88).all()
    for row in rows:
        update_yst_status(row, 2, sxmc, db)

    rows = db.query(YstQyyjyaEntity).filter(YstQyyjyaEntity.status == 99).all()
    for row in rows:
        update_yst_status(row, 3, sxmc, db)

# 应急演练总结
def check_yjylzj_ok(db: Session):
    sxmc = '应急演练总结'
    rows = db.query(YstYjylzjEntity).filter(YstYjylzjEntity.status == 88).all()
    for row in rows:
        update_yst_status(row, 2, sxmc, db)

    rows = db.query(YstYjylzjEntity).filter(YstYjylzjEntity.status == 99).all()
    for row in rows:
        update_yst_status(row, 3, sxmc, db)

def update_yst_status(row: any, status:int, sxmc: str, db: Session):
    sfzh = row.sfzh
    bzid = row.bzid

    if status == 2:
        row.status = status
        row.updateTime = datetime.now()
        db.commit()

        jdsm = '茂名市应急管理局审核通过您所递交的申请材料。'
        process_entity = YstProcessEntity(bzid=bzid, sfzh=sfzh, zt=1, ztsm='审核通过', jdsm=jdsm, djsj=unixstamp()) 
        db.add(process_entity)
        db.commit()

        jdsm = f"您的{sxmc}办理申请已成功办结。"
        process_entity = YstProcessEntity(bzid=bzid, sfzh=sfzh, zt=4, ztsm='已办结', jdsm=jdsm, djsj=unixstamp()+1) 
        db.add(process_entity)
        db.commit()

    if status == 3:
        row.status = 3
        row.updateTime = datetime.now()
        db.commit()

        jdsm = '茂名市应急管理局已驳回您所递交的申请材料。'
        process_entity = YstProcessEntity(bzid=bzid, sfzh=sfzh, zt=9, ztsm='已驳回', jdsm=jdsm, djsj=unixstamp()) 
        db.add(process_entity)
        db.commit()