#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from fastapi import APIRouter, Request, Depends

from . import material_type
from . import warehouse
from . import warehouse_root
from . import material
from . import m_count
from . import procurement
from . import dispatch
from . import warehouse_movement
from . import warehouse_inbound
from . import warehouse_outbound
router = APIRouter()


router.include_router(material_type.router, prefix="/type", tags=["物资种类"])
router.include_router(warehouse.router, prefix="/warehouse", tags=["仓库"])
router.include_router(warehouse_root.router, prefix="/warehouse_room", tags=["仓库库房"])
router.include_router(material.router, prefix="/material", tags=["物资"])
router.include_router(m_count.router, prefix="/count", tags=["物资统计"])
router.include_router(procurement.router, prefix="/procurement", tags=["物资申报"])
router.include_router(dispatch.router, prefix="/dispatch", tags=["物资调度"])
router.include_router(warehouse_movement.router, prefix="/warehouse_movement", tags=["库存明细"])
router.include_router(warehouse_inbound.router, prefix="/warehouse_inbound", tags=["入库"])
router.include_router(warehouse_outbound.router, prefix="/warehouse_outbound", tags=["出库"])
