#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from fastapi import APIRouter, Request, Depends
from database import get_db
from sqlalchemy.orm import Session
from models import *
from . import user
from . import menu
from . import dic
from . import dept
from . import config
from . import role
from . import area
from . import post
from . import czrz
from . import notice

import json

router = APIRouter()

router.include_router(user.router, prefix="/user") #, dependencies=[Depends(valid_access_token)]
router.include_router(menu.router, prefix="/menu") #, dependencies=[Depends(valid_access_token)]


router.include_router(dic.router, prefix="/dict")
router.include_router(dept.router, prefix="/dept")
router.include_router(role.router, prefix="/role")
router.include_router(area.router, prefix="/area")
router.include_router(config.router, prefix="/config")
router.include_router(post.router, prefix="/post")
router.include_router(czrz.router, prefix="/czrz")
router.include_router(notice.router, prefix="/notice")


