from models import *

def dept_id_get_dept_info(db,dept_id):
    # 机构id获取机构信息
    query = db.query(SysDept)
    query = query.filter(SysDept.del_flag != '2')
    query = query.filter(SysDept.dept_id == dept_id)
    return query.first()
def parent_id_get_dept_info(db,parent_id):
    query = db.query(SysDept)
    query = query.filter(SysDept.del_flag != '2')
    query = query.filter(SysDept.parent_id == parent_id)
    return query.all()

def nick_name_get_user_info(db,nickName):
    query = db.query(SysUser)
    # query = query.filter(SysUserRole.del_flag != '2')
    query = query.filter(SysUser.nick_name.like(f'%{nickName}%'))
    resutl = query.all()
    return [i.user_id for i in resutl]

def dept_id_get_user_info(db,dept_id):
    # 用户id获取用户信息
    query = db.query(SysUser)
    query = query.filter(SysUser.del_flag != '2')
    query = query.filter(SysUser.dept_id == dept_id)
    return query.all()
def user_id_get_user_info(db,user_id):
    # 用户id获取用户信息
    query = db.query(SysUser)
    query = query.filter(SysUser.del_flag != '2')
    query = query.filter(SysUser.user_id == user_id)
    return query.first()

def user_name_get_user_info(db,user_name):
    # 用户id获取用户信息
    query = db.query(SysUser)
    query = query.filter(SysUser.del_flag != '2')
    query = query.filter(SysUser.user_name == user_name)
    return query.first()

def user_id_get_user_roleIds(db,user_id):
    query = db.query(SysUserRole)
    # query = query.filter(SysUserRole.del_flag != '2')
    query = query.filter(SysUserRole.user_id == user_id)
    resutl = query.all()
    return [i.role_id for i in resutl]

def user_id_get_user_videoIds(db,user_id):
    query = db.query(SysUserVideo)
    # query = query.filter(SysUserRole.del_flag != '2')
    query = query.filter(SysUserVideo.user_id == user_id)
    resutl = query.all()
    return resutl
def user_id_get_avcon_dev_id(db,user_id):
    query = db.query(AvconUser)
    # query = query.filter(SysUserRole.del_flag != '2')
    query = query.filter(AvconUser.user_id == user_id)
    resutl =query.first()
    if resutl is not None:
        return resutl.dev_id
    return ''

def user_id_get_user_postIds(db, user_id):
    query = db.query(SysUserPost)
    query = query.filter(SysUserPost.user_id == user_id)
    resutl = query.all()
    return [i.post_id for i in resutl]

def dept_id_get_dept_post(db, dept_id):
    # print('dept_id_get_dept_post:', dept_id)
    query = db.query(SysPost)
    query = query.filter(SysPost.status == 0)
    query = query.filter(SysPost.dept_id == dept_id)
    resutl = query.all()
    return post_list_to_dict(resutl, db)


def role_list_to_dict(roles,role_id_list):
    return [
        {
            "roleId": role.role_id,
            "roleName": role.role_name,
            "roleKey": role.role_key,
            "roleSort": role.role_sort,
            "dataScope": role.data_scope,
            "menuCheckStrictly": role.menu_check_strictly,
            "deptCheckStrictly": role.dept_check_strictly,
            "status": role.status,
            "remark": role.remark if role.remark else '',
            "createTime": role.create_time.strftime('%Y-%m-%d %H:%M:%S') if role.create_time else '',
            "flag": role.role_id in role_id_list,
            "superAdmin": False
        }
        for role in roles
    ]

def role_id_list_get_user_role(db,role_id_list):
    query = db.query(SysRole)
    # query = query.filter(SysUserRole.del_flag != '2')
    query = query.filter(SysRole.role_id.in_(role_id_list))
    resutl = query.all()
    return role_list_to_dict(resutl,role_id_list)

def get_role(db,role_id_list=[]):
    query = db.query(SysRole)
    query = query.filter(SysRole.del_flag != '2')
    return role_list_to_dict(query.all(),role_id_list)


def parent_id_get_exclude_dept_info(db,dept_id):
    query = db.query(SysDept)
    query = query.filter(SysDept.del_flag != '2')

    # 排除某些部门
    if dept_id:
        query = query.filter(SysDept.dept_id != dept_id)
    return query.all()




def parent_id_get_menu_info(db,parent_id):
    query = db.query(SysMenu)
    query = query.filter(SysMenu.del_flag != '2')
    query = query.filter(SysMenu.parent_id == parent_id)
    query = query.order_by(SysMenu.order_num.asc())
    return query.all()

def role_id_get_role_menus(db,role_id):
    query = db.query(SysRoleMenu)
    # query = query.filter(SysUserRole.del_flag != '2')
    query = query.filter(SysRoleMenu.role_id == role_id)
    resutl = query.all()
    return [i.menu_id for i in resutl]

def role_id_get_role_depts(db,role_id):
    query = db.query(SysRoleDept)
    # query = query.filter(SysUserRole.del_flag != '2')
    query = query.filter(SysRoleDept.role_id == role_id)
    resutl = query.all()
    return [i.dept_id for i in resutl]

def role_id_get_role_info(db, role_id):
    query = db.query(SysRole)
    query = query.filter(SysRole.del_flag != '2')
    query = query.filter(SysRole.role_id == role_id)
    return query.first()

def get_dict_data_info(db,dict_type:str,dict_value:str):
    query = db.query(SysDictData)
    query = query.filter(SysDictData.del_flag != '2')
    query = query.filter(SysDictData.dict_type == dict_type)
    query = query.filter(SysDictData.dict_value == dict_value)
    return query.first()
def dict_type_get_dict_data_info(db,dict_type:str):
    query = db.query(SysDictData)
    query = query.filter(SysDictData.del_flag != '2')
    query = query.filter(SysDictData.dict_type == dict_type)
    return query.all()
def dict_label_get_dict_data_info(db,dict_type:str,dict_label:str):
    query = db.query(SysDictData)
    query = query.filter(SysDictData.del_flag != '2')
    query = query.filter(SysDictData.dict_type == dict_type)
    query = query.filter(SysDictData.dict_label == dict_label)
    return query.first()
def dept_id_get_ancestors_names(db,dept, ancestors_name=''):
    # print(dept)
    ancestors_name = '/' + dept.dept_name + ancestors_name
    if dept.parent_id == 0:
        return ancestors_name
    else:
        return dept_id_get_ancestors_names(db,dept_id_get_dept_info(db,dept.parent_id), ancestors_name)


def post_list_to_dict(posts, db):
    def get_det_name(dept_id):
        dept_info = dept_id_get_dept_info(db, dept_id)
        return dept_info.dept_name if dept_info is not None else ''
    
    return [
        {
            "postId": post.post_id,
            "postName": post.post_name,
            "postCode": post.post_code,
            "postCategory": post.post_category,
            "postSort": post.post_sort,
            "deptId": post.dept_id,
            "deptName": get_det_name(post.dept_id),
            "createDept": post.create_dept,
            "createBy": post.create_by,
            "status": post.status,
            "remark": post.remark,
            "createTime": post.create_time.strftime('%Y-%m-%d %H:%M:%S') if post.create_time else '',
        }
        for post in posts
    ]

def notice_list_to_dict(notices, db):
    def get_nick_name(user_id):
        user_info = user_id_get_user_info(db, user_id)
        return user_info.nick_name if user_info is not None else ''
    
    return [
        {
            "noticeId": notice.notice_id,
            "noticeTitle": notice.notice_title,
            "noticeType": notice.notice_type,
            "noticeContent": notice.notice_content,
            "createByName": get_nick_name(notice.create_by),
            "status": notice.status,
            "remark": notice.remark,
            "createTime": notice.create_time.strftime('%Y-%m-%d %H:%M:%S') if notice.create_time else '',
        }
        for notice in notices
    ]